addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid and player.mo.skin == "sonic" or player.mo.skin == "tails" or player.mo.skin == "knuckles" then
		if not(P_IsObjectOnGround(player.mo)) and not (P_PlayerInPain(player)) and not player.powers[pw_carry] then
            player.pflags = $ | PF_JUMPED
		end
		if (player.mo.skin == "sonic") then
			if player.speed <= 100*FRACUNIT then
				local balls = FixedMul(player.speed, 3*FRACUNIT/2)
				player.actionspd = balls
			end
			if (player.pflags & PF_THOKKED) and not (player.pflags & PF_SHIELDABILITY) and not (P_IsObjectOnGround(player.mo)) then
				player.mo.state = S_PLAY_FALL
			end
		end
		if (player.mo.skin == "knuckles")
		and (player.pflags & PF_GLIDING)
		and (player.speed > 10*FRACUNIT)
		and not (player.mo.momz > 0*FRACUNIT) then
			player.mo.momz = 0*FRACUNIT
		end
	end
end)